@use kitchen_sink::ArcRichCrateVersion;
@use chrono_humanize::HumanTime;
@use crate::limit_description_len;
@use crate::render_maybe_markdown_str;
@use crate::templates::labels_html;
@use crate::Urler;
@use kitchen_sink::Origin;
@use kitchen_sink::RichCrate;
@use render_readme::Renderer;

@(crates: &[(ArcRichCrateVersion, RichCrate)], url: &Urler, markup: &Renderer, most_recently_published_list: bool)

@for (k, all) in crates {
    <li>
        <a href="@url.krate(k)">
            <div class=h>
                <h4>@if let Some((repo, _)) = k.origin().simple_repo() {@repo.owner/}@k.short_name()</h4>
                @if let Some(desc) = k.description() {
                  <p class=desc>@render_maybe_markdown_str(&limit_description_len(desc, 100, 120, k.short_name()), markup, None, None)</p>
                }
            </div>
            <div class=meta>
                @if most_recently_published_list {
                    <span class="version"><span>@if let Origin::GitHub{..} = k.origin() {GitHub } else {v}</span>@all.most_recent_version()</span>
                    @:labels_html(k, (false, false), false, "")
                    @if let Some(at) = all.versions().iter().map(|v| &v.created_at).max() {
                        <span class=pubdate>@HumanTime::from(*at)</span>
                    }
                } else {
                    @:labels_html(k, (false, false), false, "")
                    @for k in k.keywords() {
                        <span class=k><span>#</span>@k</span>
                    }
                }
            </div>
        </a>
    </li>
}

